/***********************************************************
 * $Id$
 *
 * FancyLibs libmodbus wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/


#ifndef FANCYMODBUS_H
#define FANCYMODBUS_H

#define FANCYMODBUS_ABI 1

#ifdef WIN32
# ifdef __GNUC__
#  ifdef BUILD_fancymodbus_DLL
#   define FANCYMODBUS_API __attribute__((dllexport))
#  else
#   define FANCYMODBUS_API __attribute__((dllimport))
#  endif
# else
#  ifdef BUILD_fancymodbus_DLL
#   define FANCYMODBUS_API __declspec(dllexport)
#  else
#   define FANCYMODBUS_API __declspec(dllimport)
#  endif
# endif
#else
# ifdef __GNUC__
#  define FANCYMODBUS_INTERNAL_API __attribute__((visibility("hidden")))
# endif
#endif

#ifndef FANCYMODBUS_INTERNAL_API
#define FANCYMODBUS_INTERNAL_API
#endif

#ifndef FANCYMODBUS_API
#define FANCYMODBUS_API
#endif

namespace Fancy {
namespace Modbus {

  const char* FANCYMODBUS_API fancymodbus_version();
  const char* FANCYMODBUS_API fancymodbus_builddate();
}}

#endif // ! FANCYMODBUS_H
