/***********************************************************
 * $Id$
 *
 * FancyLibs libmodbus wrapper
 *
 * Copyright (C) 2014 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYMODBUSCONNECTIONHANDLER_H_
#define FANCYMODBUSCONNECTIONHANDLER_H_

#include <fancymodbus.h>
#include <fancyrunnable.h>

namespace Fancy {
namespace Sock {
class Device;
}

namespace Modbus {

class ModbusMapping;

class FANCYMODBUS_API ModbusConnectionHandler : virtual public Fancy::Runnable {

public:
	typedef Fancy::ObjPtr<ModbusConnectionHandler> ptr_t;

	/**
	 * Instantiate a new server instance, which will operate on the given mapping instance.
	 */
	static ptr_t newInstance(
			const Fancy::ObjPtr<Fancy::Sock::Device> &socket,
			const Fancy::ObjPtr<ModbusMapping> &mapping);

	virtual Fancy::ObjPtr<ModbusMapping> getMapping() const = 0;

protected:
	ModbusConnectionHandler();
	virtual ~ModbusConnectionHandler();
};

} /* namespace Modbus */
} /* namespace Fancy */

#endif /* FANCYMODBUSCONNECTIONHANDLER_H_ */
